#!/usr/bin/perl -w

## ######### PROJECT NAME : ##############################################
## 
## find_usb.pl
## 
## ######### PROJECT DESCRIPTION : ###
##
## Find usb 
##
## #######################################################################
##
## Made by Dayan et Pujos
##
## Started on  Mon July 22 10:43:44 2005 Dayan et Pujos
##
## #######################################################################


##########################################################################
## Declaration de librairie

use strict;
use Data::Dumper;


##########################################################################
## Variables

my $path_icon = $1 . "icon/" if ( $0 =~ m/^(.*\/)\S+$/ );

my $dialog;
my $mode_box;

my @icon		= ( "save.xpm", "rest.xpm");

my @title_general	= (	"Script Sauvegarde / Restauration",
				"Script Sauvegarde",
				"Script Restauration");

my @msg_menu_disc	= (	"Choisissez le disque usb devant recevoir la sauvegarde :",
				"Choisissez le disque usb contenant la restauration :"
				);

my @msg_menu_part	= (	"Choisissez la partition sur le disque usb devant recevoir la sauvegarde :",
				"Choisissez la partition sur le disque usb contenant la restauration :"
				);

my @msg_menu_raid	= (	"Choisissez le dossier  sauvegarder :",
				"Choisissez le dossier devant recevoir la restauration :"
				);

my $msg_menu		= "Voulez vous faire une sauvegarde ou une restauration du disque principal: ";
my $msg_ok		= "Opration effectue avec succs";
my $msg_sur		= "Cette opration entraine l'effacement complet de la partition raid principale !!!\nEtes vous sr de vouloir continuer ?";

my $msg_nodisc		= "Aucun disque usb n'a t dtect.";
my $msg_nopart		= "Aucune partition n'a t trouv sur le disque usb.";
my $msg_noraid		= "Aucun point de montage sur le systme principal n'a t trouv.";
my $msg_nomount		= "Aucune partition n'a t monte sur le systme principal.";

my @possible_action	= ("1", ". Sauvegarde", "2", ". Restauration" );
my @action		= (\&sauvegarde, \&restauration);
my $montage_usb		= "/mnt/usb_rescue";
my $choix_action	= 0;


##########################################################################
## Fonction pour dterminer le type d'affiche, et la mthode dialog  employer
sub init_dialog {
	$dialog		= "/usr/bin/dialog";
	$mode_box	= 0;

	return unless (-x "/usr/bin/Xdialog");
	return unless ( `tty` =~ m/\/dev\/pts\/|\/dev\/ttyp/ );

 	$dialog		= "/usr/bin/Xdialog";
 	$mode_box	= 1;
}

sub dialog {
	my $fenetre	= shift;
	my $msg		= shift;
	my $height	= shift;
	my $width	= shift;
	my $icon	= $path_icon . shift;

	# dialog
	unless ( $mode_box ) {
		`$dialog --title "$title_general[ $choix_action ]" --stdout --$fenetre "$msg" $height $width` unless ( $mode_box );
		return $?;
	}

	# Xdialog
	`$dialog --title "$title_general[ $choix_action ]" --fill --icon $icon --$fenetre "$msg" $height $width`;
	
	return $?;
}

sub dialog_menu {
	my $msg		= shift;
	my $height	= shift;
	my $width	= shift;
	my $icon	= $path_icon . shift;
	my $taille	= shift;
	my $chaine	= shift;
	
	my $retour_commande;

	if ( $mode_box ) {
# Xdialog
		$retour_commande = `$dialog --title "$title_general[ $choix_action ]" --icon $icon --fill --menu "$msg" $taille $height $width $chaine 2>&1`;
	}
	else {
# dialog
		$retour_commande = `$dialog --title "$title_general[ $choix_action ]" --stdout --menu "$msg" $taille $height $width $chaine`;
	}
	
	my $retour_status = $?;
	exit unless ( $retour_status == 0 );
	
	chomp $retour_commande;
	return $retour_commande;
}

sub dialog_boucle {
	if ( $mode_box ) {
# Xdialog
		`$dialog --sleep 5 --title "$title_general[ $choix_action ]" --icon $path_icon./transfert1_trans.xpm --no-buttons --infobox "" 0 0`;
		`$dialog --sleep 5 --title "$title_general[ $choix_action ]" --icon $path_icon./transfert2_trans.xpm --no-buttons --infobox "" 0 0`;
		`$dialog --sleep 5 --title "$title_general[ $choix_action ]" --icon $path_icon./transfert3_trans.xpm --no-buttons --infobox "" 0 0`;
	}
	else {
# dialog
#		$retour_commande = `$dialog --title "$title" --stdout --menu "$msg" $taille $height $width $chaine`;
	}

}


##########################################################################
## Fonctions affiche
sub affiche_ok {
	dialog("msgbox", $msg_ok, 10, 40, $icon[$choix_action-1]);
	exit;
}

sub affiche_sur {
	my $status = dialog("yesno", $msg_sur, 0, 0, "warning.xpm");

	return if ( $status == 0 );
	exit;
}

sub affiche_msg_et_sort {
	dialog("msgbox", shift, 0, 0, "warning.xpm");
	exit;
}


##########################################################################
## Fonction choix de suvegarde/restauration
sub choix_menu {
	my $chaine = '"' . (join '" "', @possible_action) . '"';
	return dialog_menu($msg_menu, 60, 40, "intro.xpm", 15, $chaine);
}

## Fonction choix de disques
sub choix_disc {
	my $chaine;
	
	foreach (@_) {
		chomp ( my $modele = `scsi_info $_ 2>/dev/null | grep MODEL | cut -d '"' -f 2` );
		chomp ( my $taille = `fdisk -l $_ 2> /dev/null | grep D | cut -d " " -f 3-4 | cut -d "," -f 1` );

		$chaine .= '"' . $_ . '" "' . $modele . "        " . $taille . '" ';
	}
	
	return dialog_menu($msg_menu_disc[$choix_action-1], 60, 40, "dd.xpm", 15, $chaine);
}

## Fonction choix de partitions
sub choix_part {
	my $disc = shift;
	my @list_part;

	foreach ( `fdisk -l $disc 2> /dev/null | grep $disc` ) {
		push @list_part, $1, int( $2 *10 / 1048576 )/10 if ( $_ =~ m/($disc\d)\s+\S*\s*\d+\s+\d+\s+(\d+)\S*\s+/ );
 	}

	## Si il n y a pas de partitons sur le disque USB, on sort
	affiche_msg_et_sort($msg_nopart) if ( scalar @list_part == 0 );

	## Il y a une seule partition, je la retourne
 	return $list_part[0] if ( scalar @list_part == 2 );

	## Menu: choix partition si il y a plusieurs partitions sur le disque usb
	my $chaine;
	for ( my $i=0; $i < scalar @list_part; $i+=2) {
		$chaine .= '"' . $list_part[$i] . '" ": ' . $list_part[$i+1] . ' Go" ';
	}
	
	return dialog_menu($msg_menu_part[$choix_action-1], 60, 40, "dd.xpm", 15, $chaine);
}

## Fonction choix de partitions
sub choix_disc_principal {
	my @list_part;

	foreach ( `grep raid /etc/fstab` ) {
		my @tab = split " ", $_;
		push @list_part, $tab[1];
 	}

	## Si il n y a pas de montages raid, on sort
	affiche_msg_et_sort($msg_noraid) if ( scalar @list_part == 0 );

	## Il y a un seul montage, je la retourne
	if ( scalar @list_part == 1 ) {
		affiche_msg_et_sort($msg_nomount) unless ( `mount | grep $list_part[0]` );
 		return $list_part[0];
	}

	## Menu: choix partition si il y a plusieurs montages raid
	my $chaine;

	for ( my $i=0; $i < scalar @list_part; $i++) {
		$chaine .= '"' . $list_part[$i] . '" "" ';
	}

	my $retour_command = dialog_menu($msg_menu_raid[$choix_action-1], 60, 40, "dd.xpm", 15, $chaine);
	affiche_msg_et_sort($msg_nomount) unless ( `mount | grep $retour_command` );
	return $retour_command;
}


##########################################################################
## Fonctions de reperage des disques et des partitions

sub liste_disque {
	## Detection des disques USB
	my @usb		= `ls -1 /proc/scsi/usb-storage/ 2>/dev/null`;
	my @device;
	chomp @usb;

	# Balade dans chaque device
	foreach my $num_usb (@usb) {
		# Pour chaque device on verifie si son numero corespond a un peripherique usb
		foreach my $dev (`ls /dev/sd?`) {
			chomp $dev;

			# On recupere l host du device pour le comparer avec l host de l usb
			my $retour = `scsi_info $dev 2>/dev/null | grep 'HOST="$num_usb"' > /dev/null && fdisk -l $dev`;
			push @device, $dev if ( $retour );
		}
	}

	return @device;
}


##########################################################################
## Sauvegarde

sub sauvegarde {
	my $partition_principale	= shift;
	my $partition_usb		= shift;
	
	my $mount = `mount $partition_usb $montage_usb 2>&1`;
	affiche_msg_et_sort($mount) if ( $mount );

	my $ret = `/usr/bin/rdiff-backup --force --exclude-other-filesystems $partition_principale $montage_usb 2>&1 >/dev/null`;
	`/usr/bin/rdiff-backup --force --remove-older-than 7D $montage_usb >/dev/null 2>&1`;
	`umount /mnt/usb_rescue`;
	
	affiche_msg_et_sort($ret) if ( $ret );
	affiche_ok();
}


##########################################################################
## Restauration

sub restauration {
	my $partition_principale	= shift;
	my $partition_usb		= shift;

	affiche_sur();

	my $mount = `mount $partition_usb $montage_usb 2>&1`;
	affiche_msg_et_sort($mount) if ( $mount );
	
	`rm -rf $partition_principale/*`;
	my $handle;
	my $pid = open ($handle, "| cd $montage_usb; cp -a . $partition_principale/") or return;	

	until ( waitpid ($pid, 1) ) {
		dialog_boucle();
	}
	
	`rm -rf $partition_principale/rdiff-backup-data`;
	`umount /mnt/usb_rescue`;
	
	affiche_ok();
}


##########################################################################
## Main

## Initialisation de l affichage
init_dialog();

## Detection des disques USB
my @device = liste_disque();

## Si il n y a pas de disques USB, on sort
affiche_msg_et_sort($msg_nodisc) if ( scalar @device == 0 );

## Menu: sauvegarde ou restauration
$choix_action = choix_menu();

## Menu: choix disque si il y a plusieurs disques usb
my $disc = $device[0];
$disc = choix_disc(@device) if ( scalar @device >= 2 );

## Menu: choix partition sur le disque usb
my $partition_usb = choix_part($disc);
## Menu: choix partition sur le disque principal
my $partition_disc_principal = choix_disc_principal();

## Action effective
$action[$choix_action-1]->( $partition_disc_principal, $partition_usb );
